var descripcion = '#ORDEN'+Math.random().toString(36).replace(/[^a-zA-Z]+/g, '').substr(0, 10);

function pago_Culqi(){
    //Configuración CULQI
    Culqi.publicKey = 'pk_test_cd52ca8315a9af36';

    let monto = localStorage.getItem('total')

    Culqi.settings({
        title: 'Tienda Simple',
        currency: 'PEN',
        description: descripcion,
        amount: parseFloat(monto * 100).toFixed(2)
    });

    Culqi.open();
    /* $('#buyButton').on('click', function(e) {
        if($("#check").is(':checked')){  
            Culqi.open();
            e.preventDefault();
        }else{
            alert('Debes aceptar los terminos y condiciones.')
        }
        Culqi.open();
        e.preventDefault();
    }); */
}

function culqi() {

    if (localStorage.getItem('carts').length === 0) {
        Swal.fire({
            type: 'error',
            title: 'Oops...',
            text: 'No hay productos, selecciona alguno',
            showConfirmButton: false,
            timer: 2000
        }).then(function () {
            window.location = "/";
        })

    }else{

        var productos = JSON.parse(localStorage.getItem('carts'))
        let monto = localStorage.getItem('total')

        if (Culqi.token) { // ¡Objeto Token creado exitosamente!
            var token = Culqi.token.id;
            var email = Culqi.token.email;
            var url = '../pagar';
            var data = {productos: productos, producto:null, token: token, email:email, monto: monto, descripcion: descripcion, _token : $('meta[name="csrf-token"]').attr('content')};
    
            console.log('Se ha creado un token para el pago:' + token);
    
            $.ajax({
                type: "POST",
                url: url,
                data: data,
                success: function(res){
                    var result = "";
                    if(res.constructor == String){
                        result = JSON.parse(res);
                    }
                    if(res.constructor == Object){
                        result = JSON.parse(JSON.stringify(res));
                    }
                    if(result.object === "charge"){
                        
                        Swal.fire({
                            type: 'success',
                            title: 'Exitoso...',
                            text: result.outcome.user_message,
                            showConfirmButton: false,
                            timer: 2000
                        })
                        //alert(result.outcome.user_message);
    
                        var urlOrden = '../orden/crear';
                        var orden = { 
                            producto:null,
                            productos: productos,
                            num_orden: result.description,
                            total: result.amount,
                            transaction_id:result.id,
                            fraud_score:result.fraud_score,
                            email: email,
                            _token : $('meta[name="csrf-token"]').attr('content')
                        };
    
                        //console.log(orden);
                        $.ajax({
                            type: "POST",
                            url: urlOrden,
                            data: orden,
                            success: function(res){
                                setTimeout(() => {
                                    localStorage.clear();
                                    window.location = "/";
                                }, 2000);
                            },
                            error: function(err){
                                console.log(err);
                            },
                        })
    
                    }if(result.object === "error"){
                        //console.log('Success: ', res);
                        Swal.fire({
                            type: 'warning',
                            title: 'Ojo...',
                            text: result.user_message,
                            showConfirmButton: false,
                            timer: 2000
                        })
                    }
                },
                error: function(error_data){
                    var data = "";
                    if(error_data.constructor == String){
                        data = JSON.parse(error_data);
                    }
                    if(error_data.constructor == Object){
                        data = JSON.parse(JSON.stringify(error_data));
                    }
                    Swal.fire({
                        type: 'error',
                        title:'Ocurrio un error...',
                        text: 'Error',
                        showConfirmButton: false,
                        timer: 2000
                    })
                },
            });
    
        } else { // ¡Hubo algún problema!
            // Mostramos JSON de objeto error en consola
            //console.log(Culqi.error);
            Swal.fire({
                type: 'error',
                title:'Ocurrio un error...',
                text: Culqi.error.user_message,
                showConfirmButton: false,
                timer: 2000
            })
        }
    }
}